#define WORK_MODE 0

#if (WORK_MODE == 0)
#include <iostream>
#include <sstream>	//	std::wstring
#include <amp.h>

using namespace concurrency;
using namespace std;

int main()
{
	//	Ư ӱ
	vector<wstring> fixed_acc(3);
	fixed_acc[0] = accelerator(accelerator::direct3d_ref).description;
	fixed_acc[1] = accelerator(accelerator::direct3d_warp).description;
	fixed_acc[2] = accelerator(accelerator::cpu_accelerator).description;

	wcout << "direct3d_ref : " << fixed_acc[0] << endl;
	wcout << "direct3d_warp : " << fixed_acc[1] << endl;
	wcout << "cpu_accelerator : " << fixed_acc[2] << endl;

	//	Ϲ ӱ
	vector<accelerator> accelerators = accelerator::get_all();
	for each (accelerator acc in accelerators)
	{
		auto check_fixed_acc = [&]()->bool {
			for each (auto fa in fixed_acc)	if (fa == acc.description)	return true;
			return false;
		};
		if(!check_fixed_acc())
			wcout << acc.description << endl;
	}

	//	Ʈ ӱ
	accelerator device(accelerator::default_accelerator);
	wcout << endl << "default accelerator is " << device.get_description() << endl << endl;

	//	ӱ Ӽ
	int i;
	for (i = 0; i < accelerators.size(); i++)
	{
		//	 ġ 
		if (i < 2)
		{
			auto device = accelerators[i];
			wcout << "-- properties --" << endl;
			wcout << "description : " << device.description << endl;
			wcout << "device_path : " << device.device_path << endl;
			wcout << "supports_cpu_shared_memory : " << (device.get_supports_cpu_shared_memory() ? "ON" : "OFF") << endl;
			wcout << "dedicated_memory : " << device.dedicated_memory << endl;
			wcout << "supports_double_precision : " << (device.get_supports_double_precision() ? "ON" : "OFF") << endl;
			wcout << "has_display : " << (device.get_has_display() ? "ON" : "OFF") << endl;
		}
	}

	//	Ʈ ӱ 缳
	//	ǿ ´ ӱ⸦ Ʈ   ִ. 
	//	⼭   ӱ 
	accelerator::set_default(accelerators[i - 1].device_path);
	accelerator new_default(accelerator::default_accelerator);
	wcout << endl << "new default accelerator is " << new_default.description << endl;

	return 0;
}
//	C++ AMP νϴ ӱ ϰ Ӽ, Ʈӱ 
#elif(WORK_MODE == 1)
#include <iostream>
#include <sstream>	//	std::wstring
#include <amp.h>
#include <amprt.h>	//	queuing_mode

using namespace concurrency;
using namespace std;

int main()
{
	//	ӱ 
	accelerator device(accelerator::default_accelerator);
	wcout << "default accelerator is " << device.get_description() << endl;

	//	ӱ 
	accelerator_view av = device.default_view;
	accelerator_view av_auto = device.create_view(queuing_mode::queuing_mode_automatic);
	accelerator_view av_imm = device.create_view(queuing_mode::queuing_mode_immediate);

	//	Ʈ ӱ ť
	if (av.queuing_mode == queuing_mode::queuing_mode_automatic)
	{
		wcout << "queuing_mode::queuing_mode_automatic" << endl;
	}
	else if (av.queuing_mode == queuing_mode::queuing_mode_immediate)
	{
		wcout << "queuing_mode::queuing_mode_immediate" << endl;
	}

	return 0;
}
//	ӱ  ťȮ
#elif(WORK_MODE == 2)
#include <iostream>
#include <amp.h>
#include <array>

using namespace std;
using namespace concurrency;

int main()
{
	std::array<int, 5> input = { 0, 1, 2, 3, 4 };
	std::vector<int> output(5);
	std::vector<int> output2(5);

	//	1. GPU޸  Բ ý۸޸ 
	concurrency::array<int, 1> a_mem(5, input.data());

	//	2. GPU޸  ý۸޸ 
	concurrency::array<int, 1> a_mem2(5);
	concurrency::copy(input.data(), a_mem2);

	//	3. Է ӱ   ý۸޸ 
	accelerator device(accelerator::default_accelerator);
	accelerator_view av = device.default_view;
	concurrency::array<int, 1> a_mem3(5, input.data(), av);

	//	GPU ޸ -> ý ޸ (copy)
	concurrency::copy(a_mem, output.data());
	//	GPU ޸ -> ý ޸ (翬)
	output2 = a_mem2;

	//	
	auto result = [](string name, std::vector<int> v) {
		std::for_each(begin(v), end(v), [&](int val)
		{
			cout << " " << name << " : " << val;
		});
	};

	result("output", output);
	cout << endl;
	result("output2", output2);
	cout << endl;

	return 0;
}
// array  
#elif(WORK_MODE == 3)
#include <iostream>
#include <amp.h>
#include <array>

using namespace std;
using namespace concurrency;

int main()
{
	std::array<int, 5> input = { 0, 1, 2, 3, 4 };
	std::vector<int> output(5);

	//	ý۸޸𸮸 ϴ GPU޸ ۻ
	concurrency::array_view<int, 1> a_mem(5, input);

	//	GPU޸   GPU޸𸮸 ý۸޸𸮿 ȭ
	a_mem.synchronize();

	//	 array_view 
	cout << "direct access : " << a_mem[0] << endl;
	//	 
	concurrency::copy(a_mem, output.data());

	std::for_each(begin(output), end(output), [](int val)
	{
		cout << val << endl;
	});

	return 0;
}
// array_view  
#elif(WORK_MODE == 4)
#include <iostream>
#include <amp.h>
#include <numeric>	//	iota

using namespace std;
using namespace concurrency;

int main()
{
	vector<int> v(5);
	iota(v.begin(), v.end(), 0);
	array_view<int, 1> a_mem(5, v);

	parallel_for_each(a_mem.extent, [=](index<1> idx) restrict(amp) {
		a_mem(idx) = a_mem(idx) * 2;
	});
	a_mem.synchronize();

	for (int i = 0; i < 5; i++)	std::cout << v[i] << std::endl;

	return 0;
}
// 0 4 ʱȭ Ͱ 2 ϴ GPUڵ
#elif(WORK_MODE == 5)
#include <iostream>
#include <amp.h>
#include <numeric>	//	iota

using namespace std;
using namespace concurrency;

//	C++ AMP  Լ  
int gpu_add(int a, int b) restrict(amp)
{
	return a + b;
}

int main()
{
	vector<int> mem(5);
	iota(mem.begin(), mem.end(), 0);
	array_view<int, 1> a_mem(5, mem);

	parallel_for_each(a_mem.extent, [=](index<1> idx) restrict(amp) {
		a_mem[idx] = gpu_add(a_mem[idx], a_mem[idx]);
	});
	a_mem.synchronize();
	for (int i = 0; i < 5; i++)	std::cout << mem[i] << std::endl;

	return 0;
}
// C++ AMPԼ  ȣ
#elif(WORK_MODE == 6)
#include <iostream>
#include <amp.h>
#include <numeric>	//	iota
#include <amp_math.h>

using namespace std;
using namespace concurrency;

int main()
{
	vector<float> v(5);
	iota(v.begin(), v.end(), 0);
	array_view<float, 1> a_mem(5, v);

	parallel_for_each(a_mem.extent, [=](index<1> idx) restrict(amp) {
		a_mem(idx) = concurrency::fast_math::sqrt(a_mem(idx));
	});
	a_mem.synchronize();
	for (int i = 0; i < 5; i++)	std::cout << v[i] << std::endl;

	return 0;
}
// 0 4 ʱȭ Ͱ 
#elif(WORK_MODE == 7)
#include <iostream>
#include <amp.h>
#include <numeric>	//	iota

using namespace std;
using namespace concurrency;

int main()
{
	//	 0  1  2  3
	//	 4  5  6  7
	//	 8  9 10 11
	//	12 13 14 15
	//	=> 
	//	  0   1   4   9 
	//	 16  25  36  49
	//	 64  81 100 121
	//	144 169 196 225
	vector<int> v(16);
	iota(v.begin(), v.end(), 0);
	array_view<int, 2> a_mem(4, 4, v);

	//	ø޸ 
	parallel_for_each(a_mem.extent, [=](index<2> idx) restrict(amp) {
		a_mem(idx) = a_mem(idx) * a_mem(idx);
	});
	a_mem.synchronize();
	cout << "< tile_static  > " << endl;
	for (int i = 0; i < 16; i++)
	{
		cout << v[i] << " ";
		if (((i + 1) % 4) == 0) cout << endl;
	}
	cout << endl;

	//	ø޸ 
	iota(v.begin(), v.end(), 0);
	a_mem.refresh();	//	  ȣ
	parallel_for_each(a_mem.extent.tile<2, 2>(), [=](tiled_index<2, 2> tidx) restrict(amp) {
		tile_static int s_local[4];	//	Ŀο  ŸϿ  ϴ ĳ
		int row = tidx.global[0];
		int col = tidx.global[1];

		//	޸  a_mem(tidx) ø޸ ġ 
		s_local[tidx.local[0], tidx.local[1]] = a_mem(tidx);

		a_mem(row, col) = s_local[tidx.local[0], tidx.local[1]] * s_local[tidx.local[0], tidx.local[1]];
	});
	a_mem.synchronize();
	cout << "< tile_static  > " << endl;
	for (int i = 0; i < 16; i++)
	{
		cout << v[i] << " ";
		if (((i + 1) % 4) == 0) cout << endl;
	}
	cout << endl;

	return 0;
}
// 0 15 ʱȭ Ͱ 
#elif(WORK_MODE == 8)
#include <iostream>
#include <amp.h>
#include <numeric>	//	iota
#include <amp_math.h>
#include <amp_graphics.h>

using namespace std;
using namespace concurrency;

int main()
{
	//	 0  1  2  3
	//	 4  5  6  7
	//	 8  9 10 11
	//	12 13 14 15
	//	=> 
	//	  0   1   4   9 
	//	 16  25  36  49
	//	 64  81 100 121
	//	144 169 196 225
	vector<int> v(16);
	iota(v.begin(), v.end(), 0);
	array_view<int, 2> a_mem(4, 4, v);

	//	ø޸ 
	parallel_for_each(a_mem.extent, [=](index<2> idx) restrict(amp) {
		a_mem(idx) = a_mem(idx) * a_mem(idx);
	});
	a_mem.synchronize();
	cout << "< tile_static  > " << endl;
	for (int i = 0; i < 16; i++)
	{
		cout << v[i] << " ";
		if (((i + 1) % 4) == 0) cout << endl;
	}
	cout << endl;

	//	ø޸ 
	iota(v.begin(), v.end(), 0);
	a_mem.refresh();	//	  ȣ
	parallel_for_each(a_mem.extent.tile<2, 2>(), [=](tiled_index<2, 2> tidx) restrict(amp) {
		tile_static int s_local[4];	//	Ŀο  ŸϿ  ϴ ĳ
		int row = tidx.global[0];
		int col = tidx.global[1];

		//	޸  a_mem(tidx) ø޸ ġ 
		s_local[tidx.local[0], tidx.local[1]] = a_mem(tidx);

		a_mem(row, col) = s_local[tidx.local[0], tidx.local[1]] * s_local[tidx.local[0], tidx.local[1]];
	});
	a_mem.synchronize();
	cout << "< tile_static  > " << endl;
	for (int i = 0; i < 16; i++)
	{
		cout << v[i] << " ";
		if (((i + 1) % 4) == 0) cout << endl;
	}
	cout << endl;

	return 0;
}
// 0 15 ʱȭ Ͱ 
#endif